<?php
class Nuts_MongoRecipe
{
	static $limit = 9;
	function get_tiny($tiny)
	{
		$select = array( '_id' => 1
					,'tiny' => 1
					,'id' => 1
					,'user' => 1
					,'tiny' => 1
					);
					
		$r = &DB::$db->recipes->findOne( array("tiny" => $tiny ), $select);
		return $r;	
	}
	function get_basic_recipe($name, $user=null)
	{
		$select = array( '_id' => 1
					,'tiny' => 1
					,'id' => 1
					,'name' => 1
					//,'textrecipe' => 0
					,'stamp' => 1
					,'user' => 1
					//,'commentrecipe' => 0
					//,'raw_ingredients' => 0
					,'tag_ingredients' => 1
					//,'tag_s_ingredients' => 0
					//,'stemm' => 0
					//,'search' => 0
					//,'comments' => 0
					,'ncomments' => 1
					,'nfavs' => 1
					,'data' => 1
					);
					
		if ($user)
			$r = &DB::$db->recipes->findOne( array("id" => urlfy2idfy($name), "user.name" => $user), $select);
		else
			$r = &DB::$db->recipes->findOne( array("_id" => $name), $select);
		return $r;	
	}	
	
	function get_recipe($name, $user=null)
	{
		if ($user)
			$r = &DB::$db->recipes->findOne(array("id" => urlfy2idfy($name), "user.name" => $user));
		else
			$r = &DB::$db->recipes->findOne( array("_id" => $name));
		return $r;	
	}
	
	function is_favorited($recipe, $user)
	{	

		return (bool)(DB::$db->users->findOne(array( '_id' =>  $user
												, "favorites._id" =>  $recipe)
												)
										
					  );
	}
	
	protected function new_recipe($user, $name, $raw_ingredients, $recipe, $comment, $data, $tag_ingredients, $stemm, $search, $edit=null)
	{
		$data['totaltime'] = $data['preptime'] + $data['cooktime'];
		$tag_s_ingredients = array();
		foreach ($tag_ingredients as $type => $list_ing)
			$tag_s_ingredients[$type] = array_values(array_filter(array_map('stemm_text', $list_ing)));
	
		$tag_i_tags = array_values(array_filter(array_map('idfy', $data['tags'])));
		
		//dump($tag_i_tags);
		
		//dump(idfy($name));

		$idfy = idfy($name);
		$collection = DB::$db->recipes;
		$obj = array( '_id' => "$user:$idfy"
					,'tiny' => new_id()
					,'id' => $idfy
					,'name' => $name
					,'textrecipe' => $recipe
					,'stamp' => new MongoDate()
					,'user' => Nuts_MongoUser::get_basic_user($user)//DB::$db->users->findOne(array('_id' => $user))
					,'commentrecipe' => $comment
					,'raw_ingredients' => $raw_ingredients
					,'tag_ingredients' => $tag_ingredients
					,'tag_s_ingredients' => $tag_s_ingredients
					,'tag_i_tags' => $tag_i_tags
					,'stemm' => $stemm
					,'search' => $search
					,'comments' => array()
					,'ncomments' => 0
					,'nfavs' => 0
					,'data' => $data
		);
		//dump($edit);
		if (!$edit){
			$c = $collection->insert($obj);
			Nuts_MongoUser::add_update($user, 'recipe', &$obj);
		}else{
			$id = $obj['_id'];
			unset($obj['_id']);
			unset($obj['tiny']);
			unset($obj['stamp']);
			unset($obj['user']);
			unset($obj['comments']);
			unset($obj['ncomments']);
			unset($obj['nfavs']);
			$cond = array('_id'=>$id);
			$collection->update($cond, array('$set'=>$obj));
		}
		
		return  $obj;
	}
	
	protected function add_comment($recipe, $user, $comment, &$info)
	{
		global $config;
		$parser = new Nuts_Parser();
	
		$parser->parse($comment, 'comment')
				->not_empty_html("El comentario no puede estar vacío");
		if(Parse::is_error()) return;

		$o_user = DB::$db->users->findOne(array('_id' =>  $user), array('name'=>1));
		$collection = DB::$db->recipes;
		$obj = array(
				'type' => 'comment' ,
				'stamp' => new MongoDate() ,
				'user' => &$o_user,
				'text' => $comment
		);
		$cond = array('_id' =>  $recipe);
		$cond2 = array('_id' => $recipe);
		$upda = array('$push' => array( "comments" => $obj ), '$inc' => array("ncomments" => 1) );
		$collection->update( &$cond, &$upda );
		
		$o_recipe = Nuts_MongoRecipe::get_basic_recipe($recipe);

		Nuts_MongoUser::add_notification( $o_recipe['user'], 'comment_recipe', array("user"=>&$o_user,"recipe"=>$o_recipe) );/*['_id']->{'$id'}*/
		return ;
	}
	
	protected function add_fav_recipe($recipe, $user)
	{

		$cond = array('_id' =>  $recipe);
		$o_user = DB::$db->users->findOne(array('_id' => $user));
		$o_recipe = Nuts_MongoRecipe::get_basic_recipe($recipe);
		$obj = array(
				'type' => 'favorited' ,
				'stamp' => new MongoDate() ,
				'user' => $o_user
		);
		
		DB::$db->recipes->update(&$cond,
							array('$push' => array( "comments" => $obj ), '$inc' => array("nfavs" => 1) )
							);
		
		DB::$db->users->update( array('_id' => $user)
						  , array('$push' => array("favorites" => $o_recipe))
						  );
		
		$obj = array('user' => &$o_user, 'recipe' => &$o_recipe);
		Nuts_MongoUser::add_update($user, 'favorited', &$obj);
		
		//dump($obj);exit();
		
		Nuts_MongoUser::add_notification( $o_recipe['user'], 'fav_recipe', $obj );/*['_id']->{'$id'}*/
		return 1;
	}
	
	
	protected function delete_fav_recipe($recipe, $user)
	{

		$obj = array(
				'type' => 'favorited' ,
				'user._id' => $user
		);
		$cond = array('_id' =>  $recipe) ;
		$upda = array( '$pull' => array( "comments" => $obj ), '$inc' => array("nfavs" => -1) );
		
		$cond2 = array('_id' =>  $user, "favorites._id" => $recipe );
		$upda2 = array('$pull' => array( "favorites" => $cond) );
				
		DB::$db->recipes->update( &$cond, &$upda );
		DB::$db->users->update(&$cond2, &$upda2);
		return 1;
		
	}
	
	
	public function split_query($query){
		//$q = $query;
		//dump($query);
		$r = array(
		'text' => array(),
		'ingr' => array(),
		'not_ingr' => array(),
		'tag' => array(),
		'not_tag' => array(),
		);
		$offset=0;
		$i = 0;

		$delimini = "\(";
		$delifin = "\(";
		$word = "[\wáéíóúñ]+";
		
		$delimini = "\(";
		$delifin = "\)";
		$nodelifin = "[^$delifin]+";
		while (preg_match(" /((i|ingrediente)\:($delimini(?P<i>$nodelifin)$delifin|(?P<i2>$word)))
							|((-i|-ingrediente)\:($delimini(?P<not_i>$nodelifin)$delifin|(?P<not_i2>$word)))
							|((e|etiqueta)\:($delimini(?P<t>$nodelifin)$delifin|(?P<t2>$word)))
							|((-e|-etiqueta)\:($delimini(?P<not_t>$nodelifin)$delifin|(?P<not_t2>$word)))
							|(?P<text>$word)
						    /iux" ,  $query = trim(substr($query, $offset)), $match, PREG_OFFSET_CAPTURE)){
			$offset = strlen($match[0][0])+$match[0][1];
			if ($match['i'][0])
				$r['ingr'][] = $match['i'][0];
			elseif ($match['i2'][0])
				$r['ingr'][] = $match['i2'][0];
			elseif ($match['t'][0])
				$r['tag'][] = $match['t'][0];
			elseif ($match['t2'][0])
				$r['tag'][] = $match['t2'][0];
			elseif ($match['not_i'][0])
				$r['not_ingr'][] = $match['not_i'][0];
			elseif ($match['not_i2'][0])
				$r['not_ingr'][] = $match['not_i2'][0];
			elseif ($match['not_t'][0])
				$r['not_tag'][] = $match['not_t'][0];
			elseif ($match['not_t2'][0])
				$r['not_tag'][] = $match['not_t2'][0];
			else
				$r['text'][] = $match['text'][0];
			$i+=1;
			if ($i>120) break;
		}
		//$query = $q;
		$inter = array_intersect($r['ingr'], $r['not_ingr']);
		$r['ingr'] = array_unique(array_diff($r['ingr'], $inter));
		$r['not_ingr'] = array_unique(array_diff($r['not_ingr'], $inter));
		
		$inter = array_intersect($r['tag'], $r['not_tag']);
		$r['tag'] = array_unique(array_diff($r['tag'], $inter));
		$r['not_tag'] = array_unique(array_diff($r['not_tag'], $inter));
		
		$r['s_ingr'] = array_values(array_filter(array_map('stemm_text', $r['ingr'])));
		$r['s_ningr'] = array_values(array_filter(array_map('stemm_text', $r['not_ingr'])));

		$r['i_tag'] = array_values(array_filter(array_map('idfy', $r['tag'])));
		
		$r['text'] = array_filter($r['text']);
		
		return $r;
	}
	
	public function update_splitted($sp, $upd){
		$u['ingr'] = array_values(array_filter(array_map('trim', explode(',', @$upd['ingr']))));
		$u['not_ingr'] = array_values(array_filter(array_map('trim', explode(',', @$upd['not_ingr']))));
		$u['tag'] = array_values(array_filter(array_map('trim', explode(',', @$upd['tag']))));
		$u['text'] = array_values(array_filter(array_map('trim', explode(',', @$upd['text']))));
		$u['max_time'] = array_values(array_filter(array_map('trim', explode(',', @$upd['max_time']))));
	
		$u['s_ingr'] = array_values(array_filter(array_map('stemm_text', @$u['ingr'])));
		$u['s_ningr'] = array_values(array_filter(array_map('stemm_text', @$u['not_ingr'])));
		
		$u['i_tag'] = array_values(array_filter(array_map('idfy', $u['tag'])));
		
		$sp = array_merge_recursive($sp, $u);
		return $sp;
	}
	
	public function split_2_uri($splitted){
		$new_q_text = implode(' ', $splitted['text']);
		$new_q_ing = implode(' ', array_map(function($a){return "ingrediente:\"$a\"";}, $splitted['ingr'] ));
		$new_q_n_ing = implode(' ', array_map(function($a){return "-ingrediente:\"$a\"";}, $splitted['not_ingr'] ));
		return implode(' ', array_filter(array($new_q_text, $new_q_ing, $new_q_n_ing)));
		
	}
	
	public function proccess_query($s_query){
		
		$r = $s_query;
		
		include_once('stemm_es.php');

		$stemm = array_values(array_filter(array_map('stemm_es::stemm', $r['text'])));
		$ingr = $r['s_ingr'];
		$ningr = $r['s_ningr'];

		$cond = array();
		if ($stemm){
			$cond['stemm'] = array( '$all' => $stemm) ;
		}
		if ($ingr)
			$cond['tag_s_ingredients.mandatory']['$all'] = $ingr;
		if ($ningr)	
			$cond['tag_s_ingredients.mandatory']['$nin'] = $ningr;
			
		if ($r['i_tag'])
			$cond['tag_i_tags']['$all'] = $r['i_tag'];
		
		return $cond;
	}
	
	public function search($cond,$init=0,$limit=50)
	{
		$r = iterator_to_array(DB::$db->recipes->find($cond)->sort(array('stamp'=>-1))->limit($limit)->skip($init));
		return $r;
	}
	
	public function count_search($cond)
	{
		return ceil(DB::$db->recipes->find($cond)->count() / Nuts_MongoRecipe::$limit);
		return $r;
	}
	
	protected function recipes($init, $limit)
	{
		return iterator_to_array(DB::$db->recipes->find()->sort(array('stamp'=>-1))->limit($limit)->skip($init));
	}
	
	protected function count_recipes()
	{

		return DB::$db->recipes->count();
	}
	
	protected function get_more_favorited()
	{
		return iterator_to_array(DB::$db->recipes->find()->sort(array('nfavs'=>-1))->limit(1));
	}
}
?>