<?php

class Nuts_User extends Nuts_MongoUser
{
	function __construct($nuts, $user=null){
		$this->nuts = $nuts;
		$this->user = $user;
	}
	public function register($user, $email, $pass, $pass2)
	{	
		$parser = new Nuts_Parser();
		$parser->parse($user, 'user')
				->not_empty("Debe introducir un nombre de usuario")
				->minlen(4, "El nombre de usuario debe tener al menos 4 caracteres")
				->maxlen(30, "El nombre de usuario no puede tener mas de 30 caracteres")
				->match("/^[a-zA-Z0-9]+$/", "El nombre de usuario no puede contener caracteres especiales ni acentos")
				->not_exist('Nuts_MongoUser::get_user', array($user), "Ya existe un usuario con ese nombre");
		$parser->parse($email, 'email')
				->not_empty("Debe introducir un correo electrónico")
				->match("/^[^@]+@[^@]+\.[^@]+$/", "El correo introducido no es válido");
		$parser->parse($pass, 'pass')
				->not_empty("Debe introducir la contraseña en los dos campos")
				->eq($pass2, "La contraseña debe ser igual en los dos campos");
		$parser->parse($pass2, 'pass2')
				->not_empty("Debe introducir la contraseña en los dos campos");
				
		if(Parse::is_error()) return;
		
		$obj = parent::register($user, $email, md5($pass));
		$this->public_login($user, $pass);
		return $obj;
	}
	public function public_login($user, $pass)
	{	
			
		$user_row = Nuts_User::get_user($user);
		if ($user_row and $user_row['pass'] == md5($pass)){
			$_SESSION['user']=array('name' => $user_row['name'], 'id' => $user_row['_id']);
			$this->nuts->loginSuccessfully();
		}
		else
		{
			$GLOBALS['config']['error']['user'] = 'Usuario incorrecto';
		}
	}
	public function logout()
	{
		unset($_SESSION['user']);
		Nuts_Nuts::successfully();
	}
	
	function get_avatar_for($id)
	{
		$folder = "static/image/avatar/";
		if (file_exists($folder . $id . ".jpg"))
			$file = $folder. $id.".jpg";
		else if (file_exists($folder . $id . ".png"))
			$file = $folder . $id . ".png";
		else
			$file = $folder . "no.png";
		return $file;
		return '[' . $folder . '][' . $file . ']';
	}

	
	function get_profile_for($id)
	{
		$folder = "static/image/profile/";
		if (file_exists($folder . $id . ".jpg"))
			$file = $folder.$id.".jpg";
		else if (file_exists($folder . $id . ".png"))
			$file = $folder . $id . ".png";
		else
			$file = $folder . "no.png";
		return $file;
	}
	
	function get_gravatar( $email, $s = 80, $d = 'identicon', $r = 'g') {
		$url = 'http://www.gravatar.com/avatar/';
		$url .= md5( strtolower( trim( $email ) ) );
		$url .= "?s=$s&d=$d&r=$r";
		return $url;
	}
	
	function set_avatar_for($id, $photo)
	{
		extract(pathinfo($photo['name']), EXTR_PREFIX_ALL, 'upload' );
		$upload_extension = strtolower($upload_extension);
		$filename='static/image/user/' . $id . '.' . $upload_extension;
		$_SESSION['user']['avatar'] = $filename;
		include_once('redimensionar.php');
		redimensionar($filename, "static/image/avatar/$id.$upload_extension" , 50, 50, false);
		redimensionar($filename, "static/image/avatar/50/$id.$upload_extension" , 50, 50, false);
		redimensionar($filename, "static/image/avatar/40/$id.$upload_extension" , 40, 40, false);
		redimensionar($filename, "static/image/avatar/28/$id.$upload_extension" , 28, 28, false);
		Nuts_Nuts::successfully();
	}
	
	function set_profile_for($id, $photo)
	{
		extract(pathinfo($photo['name']), EXTR_PREFIX_ALL, 'upload' );
		$upload_extension = strtolower($upload_extension);
		$filename='static/image/user/' . $id . '.' . $upload_extension;
		include_once('redimensionar.php');
		redimensionar($filename, "static/image/profile/$id.$upload_extension" , 160, 260 , true); //180x290; 80 * 1,62 ~= 290 
		Nuts_Nuts::successfully();
	}
	
	
	function upload_image_for($id, $photo)
	{

		if ($photo['error'] == UPLOAD_ERR_NO_FILE) 
			return;
		if ($photo['error'] !== UPLOAD_ERR_OK)
		{
			$GLOBALS['config']['error']['photo'] = "Fallo al cargar la imagen";
			return ;
		}
		extract(pathinfo($photo['name']), EXTR_PREFIX_ALL, 'upload' );
		$upload_extension = strtolower($upload_extension);
		if($upload_extension != "jpg" and $upload_extension != "png")
		{
			$GLOBALS['config']['error']['photo'] = "La imagen tiene que estar en .jpg o .png";
			return;
		}
		
		$filename='static/image/user/' . $id . '.' . $upload_extension;
		
		if(!move_uploaded_file($photo['tmp_name'], $filename))
		{
			$GLOBALS['config']['error']['photo'] = "Fallo al cargar la imagen";
			return;
		}
		if ($upload_extension != "jpg")
			@unlink('static/image/user/' . $id . '.jpg'); //eliminar
		else if ($upload_extension != "png")
			@unlink('static/image/user/' . $id . '.png'); //eliminar
	}
	
	function set_image_for($id, $photo){
		Nuts_User::upload_image_for($id, $photo);
		Nuts_User::set_avatar_for($id, $photo);
		Nuts_User::set_profile_for($id, $photo);	
		dump($GLOBALS['config']['error']);
		dump($id);
		dump($photo);
	}
	
	function change_visibility($user, $visibility)
	{
		return parent::mail_visibility($visibility, $user);
	}
	
	function delete_user($user)
	{
		parent::delete_user($user);
		@unlink('static/image/user/' . $user . '.jpg');
		@unlink('static/image/user/' . $user . '.png');
		unset($_SESSION['user']);
	}
	
	public function get_recipe_counter($user)
	{
		return parent::get_recipe_counter($user);
	}
	
	public function get_recipes_for($user)
	{
		return parent::get_recipes_for($user);
	}
	
	public function get_alternative_counter($user)
	{
		return parent::get_alternative_counter($user);
	}
	
	public function get_favorited_counter($user)
	{
		return parent::get_favorited_counter($user);
	}
	
	
	public function follow_user($following, $followed)
	{
		if ( Nuts_User::is_follow($following, $followed) )
			Nuts_User::delete_follow($following, $followed);
		else 
			Nuts_User::add_follow($following, $followed);
	}
	
	public function add_text_update($user, $text)
	{
		$parser = new Nuts_Parser();
		$parser->parse($text, 'text_update')
				->not_empty_html("No puede estar vacío")
				;
		if(Parse::is_error()) return;
		
		Nuts_MongoUser::add_update($user, 'text', &$text);
		Nuts_Nuts::successfully();
	}
	
	
	public function send_confirm_mail($email, $tok)
	{
		global $config;
		DB::$db->mails->insert(array('email'=>$email, 'tok'=>$tok));
		$config['email'] = $email;
		$config['tok'] = $tok;
	}
	
	public function register_mail($mail)
	{	
		global $config;
		require_once('recaptcha/recaptchalib.php');
		$privatekey = "6LekR8cSAAAAAD-mbafK5QRIAcp6y0klc4Qzpm0A";
		$publickey = "6LekR8cSAAAAAHYI7PnCojeJ8vV-yWrV1ZABdsL6"; // you got this from the signup page

		if ($_POST["recaptcha_challenge_field"]){
		$resp = recaptcha_check_answer ($privatekey,
									$_SERVER["REMOTE_ADDR"],
									$_POST["recaptcha_challenge_field"],
									$_POST["recaptcha_response_field"]);
		  if ($resp->is_valid) {
			Nuts_User::send_confirm_mail($mail, new_id().new_id().new_id().new_id().new_id().new_id().new_id().new_id());
			$_SESSION['register']['steep'] = 1;
		  }else{
			$config['showcaptcha'] = recaptcha_get_html($publickey, $resp->error);
		  }
		}else{
			$config['showcaptcha'] = recaptcha_get_html($publickey);
		}
		
		
	}
	public function add_comment_update($update, $user, $comment)
	{
	
		$parser = new Nuts_Parser();
		$parser->parse($comment, 'comment_update')
				->not_empty_html("El comentario no puede estar vacío");
				
		if(Parse::is_error()) return;
		
		if (!$comment)
		{
			$GLOBALS['config']['error']['commentUpdate'] = 'El comentario no puden estar vacío';
			return;
		}
		parent::add_comment_update($update, $user, $comment);
		Nuts_Nuts::successfully();
	}

	public function set_data_profile($id, $data)
	{
		parent::set_data_profile($id, $data);
		Nuts_Nuts::successfully();
	}

	
	public function confirm_mail($email, $tok1, $tok2)
	{
		dump($email,'email');
		dump($tok, 'token');
	}

	public function public_register($user, $email, $pass, $pass2){
		Nuts_User::register($user, $email, $pass, $pass2);
	}
	
	public function public_changeImageUser(){
		Nuts_User::set_image_for($_SESSION['user']['name'], $_FILES['profile']);
	}
	
	public function public_deleteUser(){
		Nuts_User::delete_user($_SESSION['user']['id']);
	}
	
	public function public_follow($follow){
		Nuts_User::follow_user($_SESSION['user']['id'], $follow);
	}
	
	public function public_sendMessage($to, $text, $id){
		Nuts_User::send_message($_SESSION['user']['id'], $to, $text, $id);
	}
	
	public function public_addUpdate($text){
		Nuts_User::add_text_update($_SESSION['user']['id'], $text);
	}
	
	public function public_registerMail($email){
		Nuts_User::register_mail($email);
	}
	public function public_addCommentUpdate($id, $text){
		Nuts_User::add_comment_update($id, $_SESSION['user']['id'], $text);
	}
	
	public function public_setDataProfile(){
		 Nuts_User::set_data_profile($_SESSION['user']['id'], $_POST);
	}
	
	public function public_exit(){
		 Nuts_User::logout();
	}
	
	
	public function public_removeUpdate($id){
		Nuts_MongoUser::remove_update($_SESSION['user']['id'], $id);
	}
	
}

if (isset($_GET['notif']) and $_GET['notif']) Nuts_User::read_notification($_SESSION['user']['id'], $_GET['notif']);

?>